package org.refal.j;

public class BigMask extends Container {

    protected long value;

    protected int length=0;

    public static final int MAXLEN = 64;

    public BigMask() {
        init(EMPTY);
    }

    public BigMask(Object[] expr) {
        init(expr);
    }

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }

    public String getMode() {
        return "MASK";
    }

    public void set(Object v) throws Error {
        if (v instanceof Number) {
            value = ((Number)v).longValue();
            length = MAXLEN;
        }
        else throw new Error("Improper object value "+v+" for mode MASK");
    }

    public Object get() {
        return new Long(value);
    }

    public void init(Object[] a) {
        //TODO
    }

/****************** Creation "interface" *********************/

    public static Object makeObject(String mode) {
        if (mode=="MASK")  {
            return new Mask();
        } else return null;
    }

    public static Referable readObject(String header, java.io.PushbackReader in, Table t)
                                    throws Exception
    {
        if (header.length()==0) {
            int c = in.read();
            in.unread(c);
            if (Character.isDigit((char)c) || c=='-' || c == '+') {
                Number number = Stream.readNumber(in);
                Referable res = (number instanceof Double? (Referable) new Real() : (Referable) new Mask());
                res.set(number);
                return res;
            }
        } else
        if (header.charAt(0)=='M') {
            Container cont = new Mask();
            if (cont.readBody(in,t))  // defined in Container
                return cont;
        }
        return null;
    }

/******************************************************************/

    public void writeObject(java.io.Writer out, Table t) throws java.io.IOException {
        out.write(String.valueOf(value));
    }

/************************************************* Virtual methods from Container: *****/
    public Object[] igetv() {
        //TODO
        return EMPTY;
        }

    Object igetn(int pos) { // null if pos>=length
        //TODO
        return null;
    }

    void   isetn(int pos, Object a) {
        //TODO
        }

    int    igetlen() {
        //TODO
        return 64;
        }

    void   isetlen(int len) {
        //TODO
    }

    void ishift(int pos, int shift) {
        //TODO
    }
}